/*------------------------------------------------------------------------*/
/* CALLVIEW.C - (C) 1990 by Jeffrey S. Donovan           Turbo C 2.0      */
/*                                                                        */
/* The actual code for CallView Ver 2.0.                                  */
/*                                                                        */
/* Jeffrey Donovan can be reached at "The Bulls & Bears BBS",             */
/* (805) 962-8206  8N1, 2400, 24 HOURS, Please post comments regarding    */
/* programming in the Programmers Forum, forum #1                         */
/*------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>

#define CALLOG_FILE_NAME "CALLER" /* Define File Name Here For Easy
				     Development. A nice addition will
				     be to change the path and directory
				     on the fly. */


#include <gap_keys.h>   /* Function Key Definitions                       */
#include <gapftype.h>   /* File Attribute Types                           */
#include <gap_glfn.h>   /* GAP global functions. Little extras and algos. */
#include <gap_cllr.h>   /* GAP CALLER Toolkit File                        */


/* The remaining code is used for the sample program, for your own        */
/* applications all you need is gap_cllr.h, although feel free to expand  */
/* on the sample program is you wish.                                     */


/* WRITE SINGLE LOG     - Write one record of a call, for detail reporting*/
/*------------------------------------------------------------------------*/
void pascal write_single_log(long position)
   {
   callog_file_pos=position;         /* Set position to loop           */
   read_call_file();                 /* Read caller log file           */
   cprintf("%10s %7s %5s %5s %4s %8s %s",
	    callog.dtstmp,callog.dtime,callog.code,callog.val,callog.ctm,callog.num,callog.event);
   }

/* WRITE LOG PAGE       - Write an entire call detail page.               */
/*------------------------------------------------------------------------*/
void pascal write_log_page(long start,long stop)
   {
   int loop,loop2,y_pos,code,current_pos;
   y_pos=1;
   for (loop=start;loop<=stop;loop++)   /* A full call = start to stop    */
      {
      gotoxy(1,y_pos);                  /* Goto position and write info.  */
      write_single_log(loop);
      ++y_pos;                          /* Increment y screen position    */
      }
  }

/* SHOW DETAIL LOG      - Show the specific call in detail, with scroll.  */
/*------------------------------------------------------------------------*/
void pascal show_detail_log(long start,long stop)
   {
   int a_page=16,loop,KEY;
   long current_pos,new_start,new_stop;
   unsigned char end_func;

   for (loop=2;loop<=25;loop++) {gotoxy(1,loop);clreol();}
   textbackground(1);gotoxy(1,25);clreol();textbackground(0);

   textcolor(10);gotoxy(2,3); cprintf("Detail ");
   textcolor(11);cprintf("For ");textcolor(12);cprintf("%s",info.name);
   textcolor(11);cprintf(" On ");textcolor(12);write_date(info.call_date);
   textcolor(15);
   gotoxy(2,5);cprintf("      DATE   TIME  CODE   VAL  ERR    M-NUM  EVENT");
   gotoxy(2,6);cprintf("-------------------------------------------------------------------------------");
   textcolor(14);

   current_pos=stop;              /* Set initial variables.               */
   new_start=start;
   new_stop=stop;
   if ((new_stop-new_start)>a_page) new_stop=new_start+a_page;

   window(1,7,80,23);             /* Write the first page of logs         */
   write_log_page(new_start,new_stop);

   if ((stop-start)>a_page)       /* If more than 1 page, then allow scrol*/
      {
      window(1,1,80,25);textbackground(1);
      gotoxy(2,25); textcolor(11); cprintf("  %c)",25);textcolor(14);cprintf("Scroll Down");
      gotoxy(30,25); textcolor(11);cprintf("  %c)",24);textcolor(14);cprintf("Scroll Up");
      gotoxy(60,25);textcolor(11); cprintf(" Esc)");textcolor(14);cprintf("Exit");
      window(1,7,80,23);textbackground(0);
      end_func=0;

      while (!end_func)           /* Let user cycle through operations */
	 {                        /* or exit the detail lookup.        */
	 if (kbhit()!=0)
	    {
	    if (function_key_pressed(&KEY))
	       {
	       switch(KEY)
		  {
		  case KEY_UP   :if (new_start>start)      /* Back 1 rec. */
				    {
				    --new_start;--new_stop;
				    current_pos=new_start;
				    gotoxy(1,1);insline();gotoxy(1,1);
                                    write_single_log(current_pos);
				    }
				 break;
		  case KEY_DOWN :if (new_stop<stop)        /* Up 1 rec.   */
				    {
				    ++new_start;++new_stop;
				    current_pos=new_stop;
				    gotoxy(1,17);cprintf("\n");
				    gotoxy(1,17);write_single_log(current_pos);
				    }
				 break;
		  case KEY_ESC  :end_func=1;               /* Exit Detail.*/
				 break;

		  } /* switch                */
	       }    /* function key perssed  */
	    }       /* kbhit                 */
	 }          /* while not end_func    */
      window(1,1,80,25);
      }
   else                           /* If no more than one page, wait for   */
      {                           /* user to press a key to exit.         */
      window(1,1,80,25);textbackground(1);
      gotoxy(2,25);textcolor(11);cprintf("Press Any Key To Return..");
      textbackground(0);
      KEY=getch();
      }
   }


/* SHOW LOG FIELDS      - Show the field titles on screen.                */
/*------------------------------------------------------------------------*/
void pascal show_log_fields(void)
   {
   int loop;
   for (loop=2;loop<=7;loop++) {gotoxy(1,loop);clreol();}
   textcolor(11);
   gotoxy(2,3); cprintf("Date Of Call   : ");
   gotoxy(2,4); cprintf("Caller's Name  : ");
   gotoxy(2,5); cprintf("Total Time On  : ");
   gotoxy(2,6); cprintf("Log-On  Time   : ");
   gotoxy(2,7); cprintf("Log-Off Time   : ");
   gotoxy(2,9); cprintf("Baud Rate      : ");
   gotoxy(2,10);cprintf("Log Off Correct: ");
   gotoxy(2,12);cprintf("New User       : ");
   gotoxy(55,3);cprintf("Total Downloads: ");
   gotoxy(55,4);cprintf("Total Uploads  : ");
   gotoxy(55,5);cprintf("Total Bulletins: ");
   gotoxy(55,6);cprintf("Total Mssg Left: ");
   gotoxy(55,7);cprintf("Total Forums Jn: ");
   gotoxy(55,8);cprintf("Total Doors Opn: ");
   }


/* SHOW LOG ENTRY       - Show actual data on single call.                */
/*------------------------------------------------------------------------*/
void pascal show_log_entry(long start,long stop)
   {
   int loop;
   textcolor(12);
   clear_line_from_to(19,54,3);
   clear_line_from_to(19,54,4);
   clear_line_from_to(19,54,5);
   clear_line_from_to(19,54,6);
   clear_line_from_to(19,54,7);
   clear_line_from_to(19,54,9);
   clear_line_from_to(19,54,10);
   clear_line_from_to(19,54,12);
   clear_line_from_to(2,54,15);
   clear_line_from_to(73,79,3);
   clear_line_from_to(73,79,4);
   clear_line_from_to(73,79,5);
   clear_line_from_to(73,79,6);
   clear_line_from_to(73,79,7);
   clear_line_from_to(73,79,8);

   gotoxy(19,3);write_date(info.call_date);
   gotoxy(19,4);cprintf("%s",info.name);
   gotoxy(19,5);write_long_time(info.total_time);
   gotoxy(19,6);write_time(info.start_time);
   gotoxy(19,7);write_time(info.stop_time);
   gotoxy(19,9);if (info.baudrate==0) cprintf("Local");else cprintf("%ld",info.baudrate);
   gotoxy(19,10);if (info.log_off_prop) cprintf("Yes");else cprintf("No");
   gotoxy(19,12);if (info.new_user) {textcolor(10);cprintf("Yes");textcolor(12);}
   else cprintf("No");
   gotoxy(73,3);cprintf("%d",info.total_dnloads);
   gotoxy(73,4);cprintf("%d",info.total_uploads);
   gotoxy(73,5);cprintf("%d",info.total_bulletins);
   gotoxy(73,6);cprintf("%d",info.total_messages);
   gotoxy(73,7);cprintf("%d",info.total_forums);
   gotoxy(73,8);cprintf("%d",info.total_doors);

   if (stop+1==NUMBER_CALLOG_RECORDS)   /* If we are at end, then this was*/
      {                                 /* the last call.                 */
      gotoxy(2,15);textcolor(12);cprintf("This Is The Last Call Made To System");
      }
   if (start==0)                        /* If we are at end, then this was*/
      {                                 /* the last call.                 */
      gotoxy(2,15);textcolor(12);cprintf("This Is The First Call In The Callers Log");
      }
   }


/* SHOW LAST 15 SINGLE  - Show a single call for the last 15 calls func.  */
/*------------------------------------------------------------------------*/
void pascal show_last_15_single(overall_info *new_info,int y_pos)
   {
   gotoxy(1,y_pos);textcolor(12);
   write_date(new_info->call_date);
   textcolor(14);cprintf(" %s",new_info->name);
   gotoxy(42,y_pos);write_short_time(new_info->total_time);cprintf(" ");
   gotoxy(55,y_pos);if (new_info->baudrate==0) cprintf("  Local");
   else cprintf(" %6ld ",new_info->baudrate);
   gotoxy(63,y_pos);if (new_info->new_user) {textcolor(12);cprintf("New");}
   else cprintf("    ");

   textcolor(14);gotoxy(68,y_pos);
   textcolor(10);if (new_info->total_dnloads>0) cprintf(" *");else cprintf("  ");
   textcolor(11);if (new_info->total_uploads>0) cprintf(" *");else cprintf("  ");
   textcolor(12);if (new_info->total_bulletins>0) cprintf(" *");else cprintf("  ");
   textcolor(13);if (new_info->total_messages>0) cprintf(" *");else cprintf("  ");
   textcolor(14);if (new_info->total_forums>0) cprintf(" *");else cprintf("  ");
   textcolor(15);if (new_info->total_doors>0) cprintf(" *");else cprintf("  ");
   }


/* SHOW LAST 15 CALLERS - Show the last 15 calls made to system.          */
/*------------------------------------------------------------------------*/
void pascal show_last_15_callers(void)
   {
   int number,y_pos,loop;
   long caller_start,caller_stop;

   for (loop=2;loop<=25;loop++) {gotoxy(1,loop);clreol();}

   gotoxy(68,2);
   textcolor(10);cprintf(" D");
   textcolor(11);cprintf(" U");
   textcolor(12);cprintf(" B");
   textcolor(13);cprintf(" M");
   textcolor(14);cprintf(" F");
   textcolor(15);cprintf(" D");
   gotoxy(68,3);
   textcolor(10);cprintf(" N");
   textcolor(11);cprintf(" P");
   textcolor(12);cprintf(" L");
   textcolor(13);cprintf(" S");
   textcolor(14);cprintf(" O");
   textcolor(15);cprintf(" O");
   gotoxy(68,4);
   textcolor(10);cprintf(" L");
   textcolor(11);cprintf(" L");
   textcolor(12);cprintf(" L");
   textcolor(13);cprintf(" S");
   textcolor(14);cprintf(" R");
   textcolor(15);cprintf(" O");
   gotoxy(68,5);
   textcolor(10);cprintf(" D");
   textcolor(11);cprintf(" D");
   textcolor(12);cprintf(" T");
   textcolor(13);cprintf(" G");
   textcolor(14);cprintf(" M");
   textcolor(15);cprintf(" R");

   for (loop=1;loop<=80;loop++)
      {gotoxy(loop,6);cprintf("%c",196);}
   gotoxy(67,6);cprintf("%c",194);
   for (loop=7;loop<=23;loop++)
      {gotoxy(67,loop);cprintf("%c",179);}
   for (loop=1;loop<=80;loop++)
      {gotoxy(loop,24);cprintf("%c",196);}
   gotoxy(67,24);cprintf("%c",193);

   textcolor(11);gotoxy(2,3);cprintf("Node #%d",node_number);
   textcolor(15);cprintf("  The Last 15 Calls Received, Starting With Last Call.");
   textcolor(12);gotoxy(7,5);cprintf("Date");
   textcolor(14);gotoxy(12,5);cprintf("Name");
   gotoxy(42,5);cprintf("Total  Time");
   gotoxy(58,5);cprintf("Baud");
   textcolor(12);gotoxy(63,5);cprintf("New");
   textcolor(11);gotoxy(2,25);cprintf("Press Any Key To Return To Main..");

   y_pos=8;                                         /* Set initial vars.  */
   number=15;
   if (find_last_caller(&caller_start,&caller_stop))/* If we can find last*/
      {                                             /* caller, then go    */
      show_last_15_single(&info,y_pos-1);           /* backwards for 15   */
      for (loop=number;loop>=0;loop--)              /* more calls and show*/
	 {                                          /* them as we go.     */
         if (find_previous_call(&caller_start,&caller_stop))
	    {
	    show_last_15_single(&info,y_pos);
	    ++y_pos;
	    }
	 }
      }
   loop=getch();
   for (loop=2;loop<=23;loop++) {gotoxy(1,loop);clreol();}
   }


/* MAIN MENU            - The main menu.                                  */
/*------------------------------------------------------------------------*/
void pascal main_menu(void)
   {
   textbackground(0);clrscr();
   textbackground(1);
   gotoxy(1,23);clreol();gotoxy(1,24);clreol();gotoxy(1,25);clreol();gotoxy(1,1);clreol();
   gotoxy(2,1);  textcolor(10);cprintf("Call-View 2.0, A Utility For GAP SYSOPS.");
   textcolor(11);cprintf("   (C)Copyright 1990 Jeffrey Donovan");
   gotoxy(2,23); textcolor(11);cprintf("   %c)",26);textcolor(14);cprintf("Next Call");
   gotoxy(22,23);textcolor(11);cprintf("   %c)",27);textcolor(14);cprintf("Previous Call");
   gotoxy(2,24);textcolor(11);cprintf("Home)");textcolor(14);cprintf("First Call");
   gotoxy(22,24);textcolor(11);cprintf(" End)");textcolor(14);cprintf("Last Call");

   gotoxy(44,23);textcolor(11);cprintf("  F1)");textcolor(14);cprintf("Detail Call");
   gotoxy(61,23);textcolor(11);cprintf("  F2)");textcolor(14);cprintf("Last 15 Calls");
   gotoxy(44,24);textcolor(11);cprintf("  F3)");textcolor(14);cprintf("Change Node");
   gotoxy(61,24); textcolor(11);cprintf("  F4)");textcolor(14);cprintf("Prgm Info");
   gotoxy(2,25); textcolor(11);cprintf(" Esc)");textcolor(14);cprintf("Quit");
   textbackground(0);
   gotoxy(2,20);textcolor(15);
   if (multi_node)
      {
      cprintf("Multi-Node System");
      gotoxy(2,21);cprintf("Current Node Number : ");
      textcolor(13);
      gotoxy(25,21);cprintf("%2d",node_number);
      }
   else cprintf("Single Node System");
   }


/* PROGRAM INFO                                                           */
/*------------------------------------------------------------------------*/
void program_info(void)
   {
   int ch;
   clrscr();
   textcolor(14);gotoxy(20,1);cprintf("Information about the Call-View Program");
   textcolor(11);
   gotoxy(2,3);cprintf("Hi. My name is Jeffrey Donovan.  I am the creator of the Call View program.");
   gotoxy(2,4);cprintf("Being a GAP SYSOP and a programmer I have begun to write programs for");
   gotoxy(2,5);cprintf("the GAP system where I would like to enhance it.  The Call-View program");
   gotoxy(2,6);cprintf("was written with TLKIT2-1.ZIP, a toolkit of 'C' routines for manipulation");
   gotoxy(2,7);cprintf("of the GAP callers log.  All source code and the new version of the toolkit");
   gotoxy(2,8);cprintf("will be released by 10-7-90.");

   gotoxy(2,10);cprintf("The main function of this program is the ability to view the caller's log");
   gotoxy(2,11);cprintf("on a call by call basis, with all vital info about that call updated and ");
   gotoxy(2,12);cprintf("viewed.  You can scroll back and forth thru all the calls in the log and");
   gotoxy(2,13);cprintf("get a detailed report of every operation made on a given call.  You may ");
   gotoxy(2,14);cprintf("also choose to see a list of the last 15 calls made and the vital info.");
   gotoxy(2,15);cprintf("NOTE - The program does READ-ONLY operations to the callog file, and there");
   gotoxy(2,16);cprintf("is no danger of accidental erasure, etc.  I use this program every time I");
   gotoxy(2,17);cprintf("view the callog file now, and have found it to be very usefull.");

   gotoxy(2,19);cprintf("In future versions I plan to have print-out functions, and possibly a");
   gotoxy(2,20);cprintf("billing system and report generator.  Since I will be providing all code");
   gotoxy(2,21);cprintf("other programmers are invited to help out.");

   gotoxy(2,23);cprintf("Jeffrey Donovan can be reached at The Bulls & Bears BBS,(805)962-8206 N,8,1");
   gotoxy(2,24);cprintf("Up to 2400. ");
   textcolor(12);cprintf("                Press Any Key....");
   getch();
   }


/* MAIN                                                                   */
/*------------------------------------------------------------------------*/
main()
    {
    int KEY;                         /* Function key pressed              */
    long caller_start,caller_stop;   /* Start and stop record #'s of call */
    unsigned char end_program;       /* Program over determination        */
    long temp_start,temp_stop,temp_current;

    callog_type   *temp_callog;
    overall_info  *temp_info;

    current_node_filename[0]=NULL;
    strcat(current_node_filename,"CALLER");

    end_program=0;

    if (open_initial_node())         /* If we can open caller file, cont. */
      {                              /* Then if we can find a call, cont. */
      if (find_last_caller(&caller_start,&caller_stop))
	 {
	 main_menu();                /* Show menu and the last call made. */
	 show_log_fields();
	 show_log_entry(caller_start,caller_stop);

	 while (!end_program)           /* Let user cycle through the calls  */
	    {                        /* or exit the program.              */
	    if (kbhit()!=0)
	       {
	       if (function_key_pressed(&KEY))
		  {
		  switch(KEY)
		     {
				    /* If right arrow, find next call.    */
		     case KEY_RIGHT:if (find_next_call(&caller_start,&caller_stop))
				       show_log_entry(caller_start,caller_stop);
				    break;

				    /* If left arrow, find previous call. */
		     case KEY_LEFT :if (find_previous_call(&caller_start,&caller_stop))
				       show_log_entry(caller_start,caller_stop);
				    break;

				    /* If end key, go to very last call   */
		     case KEY_END  :if (find_last_caller(&caller_start,&caller_stop))
				       show_log_entry(caller_start,caller_stop);
				    break;

				    /* If home key go to very first call  */
		     case KEY_HOME :if (find_first_caller(&caller_start,&caller_stop))
				       show_log_entry(caller_start,caller_stop);
				    break;

				    /* If F1 pressed, show detail of call */
		     case KEY_F1   :show_detail_log(caller_start,caller_stop);
				    main_menu();                /* Show menu and the last call made. */
				    show_log_fields();
				    show_log_entry(caller_start,caller_stop);
				    break;

				    /* If F2 pressed, show last 15 calls  */
		     case KEY_F2   :/* First get temp memory, then values.*/
				    temp_callog=(callog_type *)malloc(sizeof(callog_type));
				    temp_info=(overall_info *)malloc(sizeof(overall_info));
				    temp_start=caller_start;temp_stop=caller_stop;
				    temp_current=callog_file_pos;
				    *temp_callog=callog;
				    *temp_info=info;

				    /* Next show the last 15 calls        */
				    show_last_15_callers();

				    /* Now re-assign to original values   */
				    /* and free up memory.                */
				    caller_start=temp_start;caller_stop=temp_stop;
				    callog_file_pos=temp_current;
				    callog=*temp_callog;
				    info=*temp_info;
				    free(temp_info);
				    free(temp_callog);

				    /* Now re-write original template     */
				    main_menu();
				    show_log_fields();
				    show_log_entry(caller_start,caller_stop);
				    break;

				    /* If F3 pressed, let user change node*/
		     case KEY_F3   :/* First get temp memory, then values */
				    temp_callog=(callog_type *)malloc(sizeof(callog_type));
				    temp_info=(overall_info *)malloc(sizeof(overall_info));
				    temp_start=caller_start;temp_stop=caller_stop;
				    temp_current=callog_file_pos;
				    *temp_callog=callog;
				    *temp_info=info;

				    /* Next try and change node           */
				    if (change_node(&caller_start,&caller_stop))
				       {
                                       main_menu();
				       show_log_fields();
				       show_log_entry(caller_start,caller_stop);
				       }
				    else /* If no change, reassign values */
				       {
                                       caller_start=temp_start;caller_stop=temp_stop;
				       callog_file_pos=temp_current;
				       callog=*temp_callog;
				       info=*temp_info;
				       }

				    /* Now free up memory                 */
				    free(temp_info);
				    free(temp_callog);
				    break;

				    /* If F4 pressed then show info       */
		     case KEY_F4   :program_info();
				    main_menu();
				    show_log_fields();
				    show_log_entry(caller_start,caller_stop);
				    break;

				    /* If ESC pressed, then end program.  */
		     case KEY_ESC  :end_program=1;
				    break;

		     } /* switch                */
		  } /* function key perssed */
	       } /* kbhit               */
	    } /* while not end_func */
	 } /* if call found     */

      fclose(CALLOG_FILE);

      } /* if caller file opened */
    } /* program */
/*------------------------------------------------------------------------*/

